//AB2100.H: Classe principale e definizione di costanti
#ifndef _AB2100_H

#ifndef __FILETEXT_H
#include <filetext.h>
#endif  // __FILETEXT_H

#ifndef __APPLICAT_H
#include <applicat.h>   //Definizione della classe TApplication
#endif //__APPLICAT_H
                                                    
#ifndef __MASK_H
#include <mask.h>     //Definizione della maschera
#endif //__MASK_H
  
#ifndef __URLDEFID_H
#include <urldefid.h> //Definizione di BAR_ITEM(1)
#endif //__URLDEFID_H

#define ID_NULLO 0
                     
#define MOVIMENTO1     "MOVI1"
#define MOVIMENTO2     "MOVI2"
#define MOVIMENTO3     "MOVI3"
#define MOVIMENTO4     "MOVI4"
#define MOVIMENTO5     "MOVI5"

#define TIPO_TABELLA_PERIODI "TBBBD"
#define SIGLA_TABELLA_PERIODI "BB"

#define TIPO_SRELAZ "STABI"
#define TIPO_VOCI "ATAB2"

#define TIPO_VOCI "ATAB2"

//Costanti di posizionamento nel record_text
#define SIGLA_TAB_PER               1                   

//Costanti di posizionamento nel record_text dei MOVIMENTI e DETTAGLI
#define CODICE_DITTA_MOVDETT                1 
#define ANNO_BILANCIO_MOVDETT               2
#define CODICE_PERIODO_MOVDETT              3
#define CODICE_TABELLA_MOVDETT              4
#define CONTO_COGE_MOVDETT                  5
#define PROGRESSIVO_DETT_MOVDETT            6 
#define NUMERO_REG_MOVDETT                  8
#define NUMERO_RIGA_MOVDETT                 9
#define SALDO_INIZIO_ANNO_MOVDETT           13
#define PROGRESSIVO_DARE_MOVDETT            14
#define PROGRESSIVO_AVERE_MOVDETT           15
#define RICLASSIFICAZIONE_DARE_MOVDETT      16
#define RICLASSIFICAZIONE_AVERE_MOVDETT     17
#define FLAG_DA_MOVDETT                     17
#define IMPORTO_MOVDETT                     19
#define FLAG_RICLASSIFICAZIONE_MOVDETT      21
#define SALDO_INIZIO_ANNO_SLD_MOVDETT       9
#define PROGRESSIVO_DARE_SLD_MOVDETT        10
#define PROGRESSIVO_AVERE_SLD_MOVDETT       11
#define RICLASSIFICAZIONE_DARE_SLD_MOVDETT  12
#define RICLASSIFICAZIONE_AVERE_SLD_MOVDETT 13



//Costanti di posizionamento nel record_text per VOCI
#define TIPO_VOCE_VOCI        6
#define NCA_VOCI              4
#define CODVC_VOCI            1
#define CODCOMP_ANA_VOCI      2
#define DESCR1_VOCI           5
#define DESCR2_VOCI           43
#define VOCI_INCIDENZA        41

//Costanti di posizionamento nel record_text per SOTTORELAZIONI
#define CODAN_SOTTOREL        1
#define CODVC_SOTTOREL        2
#define NCOMP_SOTTOREL        3
#define NSREL_SOTTOREL        5

//classe derivata nella quale viene gestita la funzione di trasferimento
class TRiceTras: public TApplication
{
  protected:
    TFile_text* _trasfile;      //File di testo
    
  public:
    virtual bool create();
    virtual bool destroy();
    virtual bool menu(MENU_TAG) pure;//Gli dico che non  implementata in questa classe, ma obbligatoriamente in un'altra
    //Seleziona da quale file prelevare le informazioni del tracciato record
//    void set_config_name(TString&,TMask&);
    TFile_text* set_config_name(TString&,const TMask&, const TFilename&);
    TRiceTras() {}
    virtual ~TRiceTras() {}
};        

class TABfile_text: public TFile_text
{ 
  TAssoc_array _last_id;
  static long _idcaradd;
  long _idncomp;
  long _idcoldich;
  TString _codvc_prec;
protected:
  //  virtual void preformat_field(TRelation& rel,const TFieldref&field,const TRecord_text& rec,TString &str);
  virtual void preformat_field(const TFieldref&field,TString &str,TRelation& rel,const TString &tipo_tr);
  void cambia_anno(TString& str);
  void cambia_data(TString& str);
  virtual bool pre_writerel(TRelation& rel,const TRecord_text& rec); 
  void scrivi_temp_link(TRelation& rel,const TRecord_text& rec);
public:                  
  TABfile_text(const char* file_name, const char* set_config_name);
  virtual ~TABfile_text() {}
};


#endif //_AB2100_H
