#ifndef __77STQC_H
#define __77STQC_H

#include "77stq.h"
#include "77stqab.h"

HIDDEN const int HEADER_PRIMA_NOPOS_QC = 2;  
HIDDEN const int _NUM_FOGLIO_QC = 4; 

class TQuadroC : public TQuadroA
{                          
  enum { QC_FORMLEN = 72 };
  
  real    _ammlordo, _controbb, _somnonsog, _imponibile, _imposta, 
          _detcarfam, _detlavdip, _totdet, _ritenute;
  int     _gglav;
  bool    _devo_sommare;

protected:  
  virtual int elementi_pagina(PaginaQuadro p) const;
  virtual int prima_riga(PaginaQuadro p) const;
  virtual bool print(const long codditta, const long NumFis, const long NumNoFis);
  virtual int dic_form_len() const;
  
public:  
  bool	controlla_percentuale(TCursor& cur, const real& perc_p);
  void	stampa_corpo(TPrinter& pr);
  void	setta_importi(TPrint_section& body);
  void	leggi_importi();

  TQuadroC(const char* form, const char* quadro) : TQuadroA(form, quadro) { }
  virtual ~TQuadroC() { } 
};      

class TStampaQuadroC : public TStampaQuadroA
{
protected:    
  virtual bool user_create();

public:
  TStampaQuadroC(const char* quadro, char livel) : TStampaQuadroA(quadro, livel) { }
  virtual ~TStampaQuadroC() { }
};

#endif
