// Form per la stampa delle statistiche temporali per agente.
// Usare frmcomp.

#include "pr1400a.h"

#define G_TOTAGE  1  // Gruppo totale agenti: (provvigione e fatturato delle colonne)

// Le seguenti defines servono per identificare i campi di stampa importi



USE LF_AGENTI
JOIN LF_PROVV KEY 3 INTO CODAGE==CODAGE
END

DESCRIPTION
BEGIN
END

GENERAL
BEGIN
  OFFSET 0 0
  FONT "Courier New"
  SIZE 10
END


SECTION HEADER ODD 6

STRINGA 1 40 1
BEGIN
 KEY "nome ditta"
 PROMPT  1 1 "Ditta "
 MESSAGE _DITTA, !RAGSOC
END

STRINGA 2 10
BEGIN
 KEY "Data"
 PROMPT  76 1 "Data "
 MESSAGE _TODAY
END

NUMERO 3 7
BEGIN
 KEY "Nr. pagina"
 PROMPT  92 1 "Pagina "
 MESSAGE _PAGENO
END

NUMERO 4 32
BEGIN
 KEY "Intestazione stampa"
 PROMPT  40 2 "Stampa statistiche temporali"
END

END


SECTION BODY ODD 9 COLUMNWISE

STRING 1 6
BEGIN
 SPECIAL STRINGA INTESTAZIONE "Agente" "Agente"
 SPECIAL NUMERO OFFSET "0" "Offset iniziale campo"
 SPECIAL STRINGA FINCATURA "XX" "Fincatura sinistra e destra"
 KEY "Codice agente"
 PROMPT 1 1 ""
 FIELD CODAGE
 MESSAGE RESET,G_TOTAGE@
END

STRING 2 30
BEGIN
 SPECIAL STRINGA INTESTAZIONE "Ragione sociale" "Ragione sociale"
 SPECIAL NUMERO OFFSET "0" "Offset iniziale campo"
 SPECIAL STRINGA FINCATURA "XX" "Fincatura sinistra e destra"
 KEY "Ragione Sociale agente"
 PROMPT 2 1 ""
 FIELD RAGSOC
END

STRINGA 3 7
BEGIN
  SPECIAL STRINGA INTESTAZIONE "@CMese" "Mese (1)"
  SPECIAL NUMERO OFFSET "0" "Offset iniziale campo"
  SPECIAL STRINGA FINCATURA "XX" "Fincatura sinistra e destra"
  KEY "Mese (1)"
  PROMPT 3 1 ""
END

NUMBER 4 14
BEGIN
 SPECIAL STRINGA INTESTAZIONE "@CFatturato" "Fatturato (1)"
 SPECIAL NUMERO OFFSET "0" "Offset iniziale campo"
 SPECIAL STRINGA FINCATURA "XX" "Fincatura sinistra e destra"
 KEY "Fatturato  (1)"
 PROMPT 4 1 ""
END

NUMBER 5 14
BEGIN
 SPECIAL STRINGA INTESTAZIONE "@CProvvigione" "Provvigione (1)"
 SPECIAL NUMERO OFFSET "0" "Offset iniziale campo"
 SPECIAL STRINGA FINCATURA "XX" "Fincatura sinistra e destra"
 KEY "Provvigione  (1)"
 PROMPT 5 1 ""
END

STRINGA 6 7
BEGIN
  SPECIAL STRINGA INTESTAZIONE "@CMese" "Mese (2)"
  SPECIAL NUMERO OFFSET "0" "Offset iniziale campo"
  SPECIAL STRINGA FINCATURA "XX" "Fincatura sinistra e destra"
  KEY "Mese (2)"
  PROMPT 6 1 ""
END

NUMBER 7 14
BEGIN
 SPECIAL STRINGA INTESTAZIONE "@CFatturato" "Fatturato (2)"
 SPECIAL NUMERO OFFSET "0" "Offset iniziale campo"
 SPECIAL STRINGA FINCATURA "XX" "Fincatura sinistra e destra"
 KEY "Fatturato  (2)"
 PROMPT 7 1 ""
END

NUMBER 8 14
BEGIN
 SPECIAL STRINGA INTESTAZIONE "Provvigione" "Provvigione (2)"
 SPECIAL NUMERO OFFSET "0" "Offset iniziale campo"
 SPECIAL STRINGA FINCATURA "XX" "Fincatura sinistra e destra"
 KEY "Provvigione  (2)"
 PROMPT 8 1 ""
END

/* La sub-section principale e' sulle righe provvigionali
 * Seguono poi 12 sottosezioni: PRS1, PRS2, PRS3, PRS4, PRS5, PRS6 ecc..
 * tutte con altezza minima 0 e nascoste, in quanto servono solo per 
 * effettuare totalizzazioni.
 * Ognuna avra' una condizione di raggruppamento diverso, (STREXPR) settata
 * a run-time dal programma: il controllo viene effettuato sul
 * range della data e sul numero di riga (sempre uguale ad 1, per evitare
 * che faccia le somme piu' volte dello stesso totale documento).
 * La condizione qui elencata (LF_PROVV->CODAGE==LF_AGENTI->CODAGE) e' puramente
 * fittizia.
 * Il totale delle sottosezioni e' 12, perche' le statistiche sono,
 * al massimo, per anno:  il raggruppamento minimo e' di un mese.
 * I casi limite sono percio' questi: tutto l'anno con raggruppamento di
 * 1 mese alla volta oppure tutto l'anno in un raggruppamento unico di 12
 * mesi.
 */
 
SECTION PRS  1 0 0 FILE LF_PROVV
  FLAGS "H"
   
  SECTION PRS1 1 0 0 STREXPR LF_PROVV->CODAGE==LF_AGENTI->CODAGE
    FLAGS "H"
    
          STRING 101 7
          BEGIN
            KEY "Raggruppamento mese (1)"
            PROMPT 3 1 ""
            FLAGS "D"
            MESSAGE _MONTHRANGE|COPY,F_MON1
          END
          
          NUMBER 201 14
          BEING
            KEY "Fatturato (1)"
            PROMPT 4 1 ""
            PICTURE "."
            FIELD LF_PROVV->IMPDOC
            FLAGS "H"
            MESSAGE ADD,F_TOTFAT|ADD,F_FAT1
          END
  
          NUMBER 301 14
          BEING
            KEY "Provvigione (1)"
            PROMPT 5 1 ""
            PICTURE "."
            FIELD LF_PROVV->IMPPRDOC
            FLAGS "H"
            MESSAGE ADD,F_TOTPRO|ADD,F_PRO1
          END
  END
          
  SECTION PRS2 1 0 0 STREXPR LF_PROVV->CODAGE==LF_AGENTI->CODAGE
    FLAGS "H"
  
          STRING 102 7
          BEGIN
            KEY "Raggruppamento mese (2)"
            PROMPT 6 1 ""
            FLAGS "D"
            MESSAGE _MONTHRANGE|COPY,F_MON2
          END
          
          NUMBER 202 14
          BEING
            KEY "Fatturato (2)"
            PROMPT 7 1 ""
            PICTURE "."
            FIELD LF_PROVV->IMPDOC
            FLAGS "H"
            MESSAGE ADD,F_TOTFAT|ADD,F_FAT2
          END
  
          NUMBER 302 14
          BEING
            KEY "Provvigione (2)"
            PROMPT 8 1 ""
            PICTURE "."
            FIELD LF_PROVV->IMPPRDOC
            FLAGS "H"
            MESSAGE ADD,F_TOTPRO|ADD,F_PRO2
          END
  END
          
  SECTION PRS3 1 0 0 STREXPR LF_PROVV->CODAGE==LF_AGENTI->CODAGE
    FLAGS "H"
  
          STRING 103 7
          BEGIN
            KEY "Raggruppamento mese (1)"
            PROMPT 3 1 ""
            FLAGS "D"
            MESSAGE _MONTHRANGE|COPY,F_MON3
          END
          
          NUMBER 203 14
          BEING
            KEY "Fatturato (1)"
            PROMPT 4 1 ""
            PICTURE "."
            FIELD LF_PROVV->IMPDOC
            FLAGS "H"
            MESSAGE ADD,F_TOTFAT|ADD,F_FAT3
          END
  
          NUMBER 303 14
          BEING
            KEY "Provvigione (1)"
            PROMPT 5 1 ""
            PICTURE "."
            FIELD LF_PROVV->IMPPRDOC
            FLAGS "H"
            MESSAGE ADD,F_TOTPRO|ADD,F_PRO3
          END
  END
          
  SECTION PRS4 1 0 0 STREXPR LF_PROVV->CODAGE==LF_AGENTI->CODAGE
    FLAGS "H"
  
          STRING 104 7
          BEGIN
            KEY "Raggruppamento mese (2)"
            PROMPT 6 1 ""
            FLAGS "D"
            MESSAGE _MONTHRANGE|COPY,F_MON4
          END
          
          NUMBER 204 14
          BEING
            KEY "Fatturato (2)"
            PROMPT 7 1 ""
            PICTURE "."
            FIELD LF_PROVV->IMPDOC
            FLAGS "H"
            MESSAGE ADD,F_TOTFAT|ADD,F_FAT4
          END
  
          NUMBER 304 14
          BEING
            KEY "Provvigione (2)"
            PROMPT 8 1 ""
            PICTURE "."
            FIELD LF_PROVV->IMPPRDOC
            FLAGS "H"
            MESSAGE ADD,F_TOTPRO|ADD,F_PRO4
          END
  END
          
  SECTION PRS5 1 0 0 STREXPR LF_PROVV->CODAGE==LF_AGENTI->CODAGE
    FLAGS "H"
  
          STRING 105 7
          BEGIN
            KEY "Raggruppamento mese (1)"
            PROMPT 3 1 ""
            FLAGS "D"
            MESSAGE _MONTHRANGE|COPY,F_MON5
          END
          
          NUMBER 205 14
          BEING
            KEY "Fatturato (1)"
            PROMPT 4 1 ""
            PICTURE "."
            FIELD LF_PROVV->IMPDOC
            FLAGS "H"
            MESSAGE ADD,F_TOTFAT|ADD,F_FAT5
          END
  
          NUMBER 305 14
          BEING
            KEY "Provvigione (1)"
            PROMPT 5 1 ""
            PICTURE "."
            FIELD LF_PROVV->IMPPRDOC
            FLAGS "H"
            MESSAGE ADD,F_TOTPRO|ADD,F_PRO5
          END
  END
          
  SECTION PRS6 1 0 0 STREXPR LF_PROVV->CODAGE==LF_AGENTI->CODAGE
    FLAGS "H"
  
          STRING 106 7
          BEGIN
            KEY "Raggruppamento mese (2)"
            PROMPT 6 1 ""
            FLAGS "D"
            MESSAGE _MONTHRANGE|COPY,F_MON6
          END
          
          NUMBER 206 14
          BEING
            KEY "Fatturato (2)"
            PROMPT 7 1 ""
            PICTURE "."
            FIELD LF_PROVV->IMPDOC
            FLAGS "H"
            MESSAGE ADD,F_TOTFAT|ADD,F_FAT6
          END
  
          NUMBER 306 14
          BEING
            KEY "Provvigione (2)"
            PROMPT 8 1 ""
            PICTURE "."
            FIELD LF_PROVV->IMPPRDOC
            FLAGS "H"
            MESSAGE ADD,F_TOTPRO|ADD,F_PRO6
          END
  END
          
  SECTION PRS7 1 0 0 STREXPR LF_PROVV->CODAGE==LF_AGENTI->CODAGE
    FLAGS "H"
  
          STRING 107 7
          BEGIN
            KEY "Raggruppamento mese (1)"
            PROMPT 3 1 ""
            FLAGS "D"
            MESSAGE _MONTHRANGE|COPY,F_MON7
          END
          
          NUMBER 207 14
          BEING
            KEY "Fatturato (1)"
            PROMPT 4 1 ""
            PICTURE "."
            FIELD LF_PROVV->IMPDOC
            FLAGS "H"
            MESSAGE ADD,F_TOTFAT|ADD,F_FAT7
          END
  
          NUMBER 307 14
          BEING
            KEY "Provvigione (1)"
            PROMPT 5 1 ""
            PICTURE "."
            FIELD LF_PROVV->IMPPRDOC
            FLAGS "H"
            MESSAGE ADD,F_TOTPRO|ADD,F_PRO7
          END
  END
          
  SECTION PRS8 1 0 0 STREXPR LF_PROVV->CODAGE==LF_AGENTI->CODAGE
    FLAGS "H"
  
          STRING 108 7
          BEGIN
            KEY "Raggruppamento mese (2)"
            PROMPT 6 1 ""
            FLAGS "D"
            MESSAGE _MONTHRANGE|COPY,F_MON8
          END
          
          NUMBER 208 14
          BEING
            KEY "Fatturato (2)"
            PROMPT 7 1 ""
            PICTURE "."
            FIELD LF_PROVV->IMPDOC
            FLAGS "H"
            MESSAGE ADD,F_TOTFAT|ADD,F_FAT8
          END
  
          NUMBER 308 14
          BEING
            KEY "Provvigione (2)"
            PROMPT 8 1 ""
            PICTURE "."
            FIELD LF_PROVV->IMPPRDOC
            FLAGS "H"
            MESSAGE ADD,F_TOTPRO|ADD,F_PRO8
          END
  END
          
  SECTION PRS9 1 0 0 STREXPR LF_PROVV->CODAGE==LF_AGENTI->CODAGE
    FLAGS "H"
  
          STRING 109 7
          BEGIN
            KEY "Raggruppamento mese (1)"
            PROMPT 3 1 ""
            FLAGS "D"
            MESSAGE _MONTHRANGE|COPY,F_MON9
          END
          
          NUMBER 209 14
          BEING
            KEY "Fatturato (1)"
            PROMPT 4 1 ""
            PICTURE "."
            FIELD LF_PROVV->IMPDOC
            FLAGS "H"
            MESSAGE ADD,F_TOTFAT|ADD,F_FAT9
          END
  
          NUMBER 309 14
          BEING
            KEY "Provvigione (1)"
            PROMPT 5 1 ""
            PICTURE "."
            FIELD LF_PROVV->IMPPRDOC
            FLAGS "H"
            MESSAGE ADD,F_TOTPRO|ADD,F_PRO9
          END
  END
          
  SECTION PRS10 1 0 0 STREXPR LF_PROVV->CODAGE==LF_AGENTI->CODAGE
    FLAGS "H"
  
          STRING 110 7
          BEGIN
            KEY "Raggruppamento mese (2)"
            PROMPT 6 1 ""
            FLAGS "D"
            MESSAGE _MONTHRANGE|COPY,F_MON10
          END
          
          NUMBER 210 14
          BEING
            KEY "Fatturato (2)"
            PROMPT 7 1 ""
            PICTURE "."
            FIELD LF_PROVV->IMPDOC
            FLAGS "H"
            MESSAGE ADD,F_TOTFAT|ADD,F_FAT10
          END
  
          NUMBER 310 14
          BEING
            KEY "Provvigione (2)"
            PROMPT 8 1 ""
            PICTURE "."
            FIELD LF_PROVV->IMPPRDOC
            FLAGS "H"
            MESSAGE ADD,F_TOTPRO|ADD,F_PRO10
          END
  END
          
  SECTION PRS11 1 0 0 STREXPR LF_PROVV->CODAGE==LF_AGENTI->CODAGE
    FLAGS "H"
  
          STRING 111 7
          BEGIN
            KEY "Raggruppamento mese (1)"
            PROMPT 3 1 ""
            FLAGS "D"
            MESSAGE _MONTHRANGE|COPY,F_MON11
          END
          
          NUMBER 211 14
          BEING
            KEY "Fatturato (1)"
            PROMPT 4 1 ""
            PICTURE "."
            FIELD LF_PROVV->IMPDOC
            FLAGS "H"
            MESSAGE ADD,F_TOTFAT|ADD,F_FAT11
          END
  
          NUMBER 311 14
          BEING
            KEY "Provvigione (1)"
            PROMPT 5 1 ""
            PICTURE "."
            FIELD LF_PROVV->IMPPRDOC
            FLAGS "H"
            MESSAGE ADD,F_TOTPRO|ADD,F_PRO11
          END
  END
          
  SECTION PRS12 1 0 0 STREXPR LF_PROVV->CODAGE==LF_AGENTI->CODAGE
    FLAGS "H"
  
          STRING 112 7
          BEGIN
            KEY "Raggruppamento mese (2)"
            PROMPT 6 1 ""
            FLAGS "D"
            MESSAGE _MONTHRANGE|COPY,F_MON12
          END
          
          NUMBER 212 14
          BEING
            KEY "Fatturato (2)"
            PROMPT 7 1 ""
            PICTURE "."
            FIELD LF_PROVV->IMPDOC
            FLAGS "H"
            MESSAGE ADD,F_TOTFAT|ADD,F_FAT12
          END
  
          NUMBER 312 14
          BEING
            KEY "Provvigione (2)"
            PROMPT 8 1 ""
            PICTURE "."
            FIELD LF_PROVV->IMPPRDOC
            FLAGS "H"
            MESSAGE ADD,F_TOTPRO|ADD,F_PRO12
          END
  END

END // Main subsection
        
// Totali

STRING F_MON1 7
BEGIN
  KEY "Mese (1)"
  PROMPT 3 1 ""
  MESSAGE _MONTHRANGE
END

NUMBER F_FAT1 14
BEING
  KEY "Fatturato (1)"
  PROMPT 4 1 ""
  PICTURE "."
  GROUP G_TOTAGE
END

NUMBER F_PRO1 14
  BEING
  KEY "Provvigione (1)"
  PROMPT 5 1 ""
  PICTURE "."
  GROUP G_TOTAGE
END

STRING F_MON2 7
BEGIN
  KEY "Mese (2)"
  PROMPT 6 1 ""
  MESSAGE _MONTHRANGE
END

NUMBER F_FAT2 14
BEING
  KEY "Fatturato (2)"
  PROMPT 7 1 ""
  PICTURE "."
  GROUP G_TOTAGE
END

NUMBER F_PRO2 14
  BEING
  KEY "Provvigione (2)"
  PROMPT 8 1 ""
  PICTURE "."
  GROUP G_TOTAGE
END

STRING F_MON3 7
BEGIN
  KEY "Mese (3)"
  PROMPT 3 2 ""
  MESSAGE _MONTHRANGE
END

NUMBER F_FAT3 14
BEING
  KEY "Fatturato (3)"
  PROMPT 4 2 ""
  PICTURE "."
  GROUP G_TOTAGE
END

NUMBER F_PRO3 14
  BEING
  KEY "Provvigione (3)"
  PROMPT 5 2 ""
  PICTURE "."
  GROUP G_TOTAGE
END

STRING F_MON4 7
BEGIN
  KEY "Mese (4)"
  PROMPT 6 2 ""
  MESSAGE _MONTHRANGE
END

NUMBER F_FAT4 14
BEING
  KEY "Fatturato (4)"
  PROMPT 7 2 ""
  PICTURE "."
  GROUP G_TOTAGE
END

NUMBER F_PRO4 14
  BEING
  KEY "Provvigione (4)"
  PROMPT 8 2 ""
  PICTURE "."
  GROUP G_TOTAGE
END

STRING F_MON5 7
BEGIN
  KEY "Mese (5)"
  PROMPT 3 3 ""
  MESSAGE _MONTHRANGE
END

NUMBER F_FAT5 14
BEING
  KEY "Fatturato (5)"
  PROMPT 4 3 ""
  PICTURE "."
  GROUP G_TOTAGE
END

NUMBER F_PRO5 14
  BEING
  KEY "Provvigione (5)"
  PROMPT 5 3 ""
  PICTURE "."
  GROUP G_TOTAGE
END

STRING F_MON6 7
BEGIN
  KEY "Mese (6)"
  PROMPT 6 3 ""
  MESSAGE _MONTHRANGE
END

NUMBER F_FAT6 14
BEING
  KEY "Fatturato (6)"
  PROMPT 7 3 ""
  PICTURE "."
  GROUP G_TOTAGE
END

NUMBER F_PRO6 14
  BEING
  KEY "Provvigione (6)"
  PROMPT 8 3 ""
  PICTURE "."
  GROUP G_TOTAGE
END

STRING F_MON7 7
BEGIN
  KEY "Mese (7)"
  PROMPT 3 4 ""
  MESSAGE _MONTHRANGE
END

NUMBER F_FAT7 14
BEING
  KEY "Fatturato (7)"
  PROMPT 4 4 ""
  PICTURE "."
  GROUP G_TOTAGE
END

NUMBER F_PRO7 14
  BEING
  KEY "Provvigione (7)"
  PROMPT 5 4 ""
  PICTURE "."
  GROUP G_TOTAGE
END

STRING F_MON8 7
BEGIN
  KEY "Mese (8)"
  PROMPT 6 4 ""
  MESSAGE _MONTHRANGE
END

NUMBER F_FAT8 14
BEING
  KEY "Fatturato (8)"
  PROMPT 7 4 ""
  PICTURE "."
  GROUP G_TOTAGE
END

NUMBER F_PRO8 14
  BEING
  KEY "Provvigione (8)"
  PROMPT 8 4 ""
  PICTURE "."
  GROUP G_TOTAGE
END

STRING F_MON9 7
BEGIN
  KEY "Mese (9)"
  PROMPT 3 5 ""
  MESSAGE _MONTHRANGE
END

NUMBER F_FAT9 14
BEING
  KEY "Fatturato (9)"
  PROMPT 4 5 ""
  PICTURE "."
  GROUP G_TOTAGE
END

NUMBER F_PRO9 14
  BEING
  KEY "Provvigione (9)"
  PROMPT 5 5 ""
  PICTURE "."
  GROUP G_TOTAGE
END

STRING F_MON10 7
BEGIN
  KEY "Mese (10)"
  PROMPT 6 5 ""
  MESSAGE _MONTHRANGE
END

NUMBER F_FAT10 14
BEING
  KEY "Fatturato (10)"
  PROMPT 7 5 ""
  PICTURE "."
  GROUP G_TOTAGE
END

NUMBER F_PRO10 14
  BEING
  KEY "Provvigione (10)"
  PROMPT 8 5 ""
  PICTURE "."
  GROUP G_TOTAGE
END

STRING F_MON11 7
BEGIN
  KEY "Mese (11)"
  PROMPT 3 6 ""
  MESSAGE _MONTHRANGE
END

NUMBER F_FAT11 14
BEING
  KEY "Fatturato (11)"
  PROMPT 4 6 ""
  PICTURE "."
  GROUP G_TOTAGE
END

NUMBER F_PRO11 14
  BEING
  KEY "Provvigione (11)"
  PROMPT 5 6 ""
  PICTURE "."
  GROUP G_TOTAGE
END

STRING F_MON12 7
BEGIN
  KEY "Mese (12)"
  PROMPT 6 6 ""
  MESSAGE _MONTHRANGE
END

NUMBER F_FAT12 14
BEING
  KEY "Fatturato (12)"
  PROMPT 7 6 ""
  PICTURE "."
  GROUP G_TOTAGE
END

NUMBER F_PRO12 14
  BEING
  KEY "Provvigione (12)"
  PROMPT 8 6 ""
  PICTURE "."
  GROUP G_TOTAGE
END

STRING 45 30
BEGIN
  KEY "Totale agente"
  PROMPT 2 8 "Totale agente:"
END

NUMBER F_TOTFAT 15
BEGIN
  KEY "Totale fatturato per agente"
  PROMPT 4 8 ""
  PICTURE "."
  GROUP G_TOTAGE
END

NUMBER F_TOTPRO 15
BEGIN
  KEY "Totale provvigioni per agente"
  PROMPT 5 8 ""
  PICTURE "."
  GROUP G_TOTAGE
END

END // Section body

END // Form

